/*
 *      $Id$
 *
 *   Define HSQLDB database tables needed by JIAM to persistently store information for retrying updates
 * when they fail.
 *
 */

/*
 *   Matches com.ca.iam.jiam.QueueRecord. Note that can't use TEXT tables (or handle using generic JDBC)
 * because QueueRecords are stored as serialized blobs.
 */
CREATE TABLE records
(
    commitId VARCHAR(1000) NOT NULL,
    serverName VARCHAR(100) NOT NULL,
    userName VARCHAR(1000) NOT NULL,
    userDomainName VARCHAR(1000) NOT NULL,
    password VARCHAR(100) NOT NULL,
    created TIMESTAMP NOT NULL,
    lastModified TIMESTAMP NOT NULL,
    status INTEGER NOT NULL,
    nextOpIndex INTEGER NOT NULL,
    domainHandle VARCHAR(1000) NOT NULL,
    maxTries INTEGER NOT NULL,
    userData OBJECT,
    PRIMARY KEY (commitId)
);
CREATE INDEX recordsModified ON records(lastModified);
CREATE INDEX recordsStatus ON records(status);

CREATE TABLE operations
(
    commitId VARCHAR(1000) NOT NULL,
    index INTEGER NOT NULL,
    tryCount INTEGER NOT NULL,
    status INTEGER NOT NULL,
    exception VARCHAR(1000),
    actionRecord OBJECT NOT NULL,
    messageSuccess BOOLEAN NOT NULL,
    messageEtaCode INTEGER NOT NULL,
    messageEtaTextCode CHAR(3),
    messageLdapCode INTEGER,
    messageText VARCHAR(1000),
    messageOpId VARCHAR(1000),
    messageOpDomain VARCHAR(1000),
    PRIMARY KEY (commitId, index),
    FOREIGN KEY (commitId) REFERENCES records (commitId)
);
